JUCE: HighResolutionTimer Class Reference

JUCE

Public Member Functions | Protected Member Functions | List of all members
HighResolutionTimer Class Referenceabstract
juce_core » threads

A high-resolution periodic timer. More...

`#include <juce_HighResolutionTimer.h>`

## Public Member Functions
virtual | ~HighResolutionTimer ()
| Destructor. More...
virtual void | hiResTimerCallback ()=0
| The user-defined callback routine that actually gets called periodically. More...
void | startTimer (int intervalInMilliseconds)
| Starts the timer and sets the length of interval required. More...
void | stopTimer ()
| Stops the timer. More...
bool | isTimerRunning () const noexcept
| Checks if the timer has been started. More...
int | getTimerInterval () const noexcept
| Returns the timer's interval. More...

## Protected Member Functions
| HighResolutionTimer ()
| Creates a HighResolutionTimer. More...

## Detailed Description

A high-resolution periodic timer.

This provides accurately-timed regular callbacks. Unlike the normal Timer class, this one uses a dedicated thread, not the message thread, so is far more stable and precise.

You should only use this class in situations where you really need accuracy, because unlike the normal Timer class, which is very lightweight and cheap to start/stop, the HighResolutionTimer will use far more resources, and starting/stopping it may involve launching and killing threads.

See also
  Timer

## Constructor & Destructor Documentation

## ◆ HighResolutionTimer()

HighResolutionTimer::HighResolutionTimer | ( |  | ) |
| protected

Creates a HighResolutionTimer.

When created, the timer is stopped, so use startTimer() to get it going.

## ◆ ~HighResolutionTimer()

virtual HighResolutionTimer::~HighResolutionTimer | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ hiResTimerCallback()

virtual void HighResolutionTimer::hiResTimerCallback | ( |  | ) |
| pure virtual

The user-defined callback routine that actually gets called periodically.

This will be called on a dedicated timer thread, so make sure your implementation is thread-safe!

It's perfectly ok to call startTimer() or stopTimer() from within this callback to change the subsequent intervals.

## ◆ startTimer()

void HighResolutionTimer::startTimer | ( | int | intervalInMilliseconds | ) |

Starts the timer and sets the length of interval required.

If the timer is already started, this will reset its counter, so the time between calling this method and the next timer callback will not be less than the interval length passed in.

Parameters

  intervalInMilliseconds | the interval to use (any values less than 1 will be rounded up to 1)

## ◆ stopTimer()

void HighResolutionTimer::stopTimer | ( |  | ) |

Stops the timer.

This method may block while it waits for pending callbacks to complete. Once it returns, no more callbacks will be made. If it is called from the timer's own thread, it will cancel the timer after the current callback returns.

## ◆ isTimerRunning()

bool HighResolutionTimer::isTimerRunning | ( |  | ) | const
| noexcept

Checks if the timer has been started.

Returns
  true if the timer is running.

## ◆ getTimerInterval()

int HighResolutionTimer::getTimerInterval | ( |  | ) | const
| noexcept

Returns the timer's interval.

Returns
  the timer's interval in milliseconds if it's running, or 0 if it's not.

The documentation for this class was generated from the following file:

- juce_HighResolutionTimer.h